/****************************************************************************/
/*  EmuZ-2000Xe[gZ[u c[                            */
/*--------------------------------------------------------------------------*/
/* `C`iŐV΂ɏׂjVersion (J).(ver)() */
/* H____ NH________ CT R_________________________________ */
/* 2011-01-14 Takky          Bugfix   Version 1.2 fŃAhX͈̔͂\*/
/* 2011-01-13 Takky          Bugfix   Version 1.1 }Ci[oOׂ          */
/* 2010-12-13 Takky          Coding   Version 1.0 J                */
/****************************************************************************/

/**  CN[ht@C  **/
#include <windows.h>			//  ͕K{
#include <commdlg.h>			//  t@CQƂŎg
#include <shellapi.h>			//  Drag & Drop
#include <stdio.h>				//  sprintfgĂ邩˥
#include <stdlib.h>				//  CCugpĂ邽߁B
#include <string.h>				//  XgO삪邩
#include <alloc.h>				//  [݂gĂ܂
#include <errno.h>				//  G[pgĂȂ
#include <ctype.h>				//  Kv
#include <dir.h>				//  fnsplit֐p

#include "emzedt.h"

#define	TITLE_LINE	"EmuZ-2000Xe[gZ[u c["
HANDLE	hInst;
static HGLOBAL hMem;
static char *cpStateBuffer = NULL;
static long lStateSize = 0;
static RECT rctEdit1, rctEdit2;

static int isAddr(char *);
static void upper(char *, char *);
static int CheckEmz(char *);
static void ReadSateFile(const char *);
static void BinaryProc(const char *, const char *);
static void TextProc(const char *, int , int );
static void RewriteStateFile(const char *);
int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int);
DWORD FAR PASCAL MainProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK _export About(HWND, unsigned, WORD, LONG);

static int isAddr(char *buf)
{
	if ((((*buf >='0') && (*buf <='9')) || ((*buf >='A') && (*buf <='F'))) &&
		(((*(buf+1) >='0') && (*(buf+1) <='9')) || ((*(buf+1) >='A') && (*(buf+1) <='F'))) &&
		(((*(buf+2) >='0') && (*(buf+2) <='9')) || ((*(buf+2) >='A') && (*(buf+2) <='F'))) &&
		(((*(buf+3) >='0') && (*(buf+3) <='9')) || ((*(buf+3) >='A') && (*(buf+3) <='F'))))
		return 1;
	else
		return 0;
}

static void upper(char *dst, char *src)
{
	while (*src) {
		*dst = toupper(*src);
		dst++;
		src++;
	}
}

static int CheckEmz(char *cp)
{
	if (memcmp(cp, "EMUZ", 4) != 0) return 1; /* ID error */
	if (*(cp+5) != 0x00) return 1;            /* reserved must be zero */
	if (*(cp+4) != 0x01) return 1;            /* type must be 1 */
	if (*(cp+6) != 0x00) return 1;            /* sub version must be 0 */
	if (*(cp+7) != 0x00) return 1;            /* version must be 0 */
	return 0;
}

static void ReadSateFile(const char *szFileName)
{
HANDLE hFile;
DWORD dwSize, dwErr, dwReadSize;
char buf[256];

	if (cpStateBuffer != NULL) {
		GlobalUnlock(hMem);
		GlobalFree(hMem);
		cpStateBuffer = NULL;
	}
	if ((hFile = CreateFile(szFileName, GENERIC_READ, FILE_SHARE_READ,
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL)) == INVALID_HANDLE_VALUE) {
		MessageBox(NULL, "Xe[gZ[uf[^I[vł܂BgpAANZXȂǂ̊mFĂB",
			TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return;
	}
	if ((dwSize = GetFileSize(hFile, NULL)) == 0xffffffff) {
		dwErr = GetLastError();
		if (dwErr != NO_ERROR) {
			memset(buf, 0x00, sizeof(buf));
			snprintf(buf, sizeof(buf), "Xe[gZ[uf[^̃TCY擾ŃG[܂(%d)", dwErr);
			MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
			CloseHandle(hFile);
			return;
		}
	}
	lStateSize = dwSize;
	if ((hMem = GlobalAlloc(GMEM_FIXED, dwSize)) == NULL) {
		dwErr = GetLastError();
		memset(buf, 0x00, sizeof(buf));
		snprintf(buf, sizeof(buf), "Xe[gZ[uf[^i[擾Ɏs܂(%d)", dwErr);
		MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return;
	}
	if ((cpStateBuffer = (char *)GlobalLock(hMem)) == NULL) {
		dwErr = GetLastError();
		memset(buf, 0x00, sizeof(buf));
		snprintf(buf, sizeof(buf), "Xe[gZ[uf[^i[擾Ɏs܂(%d)", dwErr);
		MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
		GlobalFree(hMem);
		CloseHandle(hFile);
		return;
	}
	ReadFile(hFile, cpStateBuffer, dwSize, &dwReadSize, NULL);
	if (lStateSize != (long)dwReadSize) {
		MessageBox(NULL, "Xe[gZ[uf[^ǂݍ߂܂ł", TITLE_LINE, MB_OK | MB_ICONSTOP);
		GlobalUnlock(hMem);
		GlobalFree(hMem);
		CloseHandle(hFile);
		return;
	}
	CloseHandle(hFile);
}

static void BinaryProc(const char *szFileName, const char *saddr)
{
long lStartAddr;
HANDLE hFile;
HGLOBAL hMem2;
DWORD dwSize, dwErr, dwReadSize;
char buf[256], *cpDumpBuffer;

	lStartAddr = strtol(saddr, NULL, 16);
	if ((hFile = CreateFile(szFileName, GENERIC_READ, FILE_SHARE_READ,
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL)) == INVALID_HANDLE_VALUE) {
		MessageBox(NULL, "_vt@CI[vł܂BgpAANZXȂǂ̊mFĂB",
			TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return;
	}
	if ((dwSize = GetFileSize(hFile, NULL)) == 0xffffffff) {
		dwErr = GetLastError();
		if (dwErr != NO_ERROR) {
			memset(buf, 0x00, sizeof(buf));
			snprintf(buf, sizeof(buf), "_vt@C̃TCY擾ŃG[܂(%d)", dwErr);
			MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
			CloseHandle(hFile);
			return;
		}
	}
	if ((lStartAddr + dwSize) >= 65536) {
		memset(buf, 0x00, sizeof(buf));
		snprintf(buf, sizeof(buf), "_vt@C傫邩JnAhX傫܂B\n_vt@CTCY:%d",
			dwSize);
		MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return;
	}
	if ((hMem2 = GlobalAlloc(GMEM_FIXED, dwSize)) == NULL) {
		dwErr = GetLastError();
		memset(buf, 0x00, sizeof(buf));
		snprintf(buf, sizeof(buf), "_vt@Ci[擾Ɏs܂(%d)", dwErr);
		MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return;
	}
	if ((cpDumpBuffer = (char *)GlobalLock(hMem2)) == NULL) {
		dwErr = GetLastError();
		memset(buf, 0x00, sizeof(buf));
		snprintf(buf, sizeof(buf), "_vt@Ci[擾Ɏs܂(%d)", dwErr);
		MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
		GlobalFree(hMem2);
		CloseHandle(hFile);
		return;
	}
	ReadFile(hFile, cpDumpBuffer, dwSize, &dwReadSize, NULL);
	if (dwSize != dwReadSize) {
		MessageBox(NULL, "_vt@Cǂݍ߂܂ł", TITLE_LINE, MB_OK | MB_ICONSTOP);
		GlobalUnlock(hMem2);
		GlobalFree(hMem2);
		CloseHandle(hFile);
		return;
	}
	CloseHandle(hFile);

	lStartAddr += 4096; /* Xe[gZ[uf[^̃C[WAhX܂ŃXLbv */
	memcpy((cpStateBuffer+lStartAddr), cpDumpBuffer, dwSize);
	GlobalUnlock(hMem2);
	GlobalFree(hMem2);
}

static void TextProc(const char *szFileName, int bSum, int bAddSum)
{
FILE *fp;
char rbuf[1024], cbuf[1024], buf[512], *cp;
long iSum, iVSum[16];
char adr[5], data[17][3];
unsigned char wbuf[16];
int iNum, i;
long lStartAddr, cdata, lsAdr, leAdr;

	if ((fp = fopen(szFileName, "r")) == NULL) {
		memset(buf, 0x00, sizeof(buf));
		snprintf(buf, sizeof(buf), "_vt@CI[vł܂(%d)", errno);
		MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
		return;
	}
	lsAdr = 65536;
	leAdr = 0;
	iSum = 0;
	memset(rbuf, 0x00, sizeof(rbuf));
	memset(cbuf, 0x00, sizeof(cbuf));
	while (fgets(rbuf, sizeof(rbuf), fp) != NULL) {
		if (strlen(rbuf) <=3) continue;
		upper(cbuf, rbuf);
		if (isAddr(cbuf)) {
			cp = strtok(cbuf, " \n");
			strncpy(adr, cp, 5);
			iNum = 0;
			while ((cp = strtok(NULL, " \n")) != NULL) {
				if (*cp != ':')
					strncpy(data[iNum], cp , 3);
				else
					strncpy(data[iNum], cp+1 , 3);
				iNum++;
				if (iNum > 16) break;
			}
			lStartAddr = strtol(adr, NULL, 16);
			if (lStartAddr >= 0 || lStartAddr <= 65535) {
				for (i=0; i<iNum-1; i++) {
					cdata = strtol(data[i], NULL, 16);
					iSum += cdata;
					wbuf[i] = (unsigned char)cdata;
				}
				if (bSum == 1) {
					if (bAddSum == 1)
						iSum += ((lStartAddr & 0x000000ff) + ((lStartAddr >> 8) & 0x000000ff));
					iSum = iSum & 0x000000ff;
					if (iSum != strtol(data[iNum-1], NULL, 16)) {
						fclose(fp);
						memset(buf, 0x00, sizeof(buf));
						snprintf(buf, sizeof(buf), "`FbNTG[\n@AhX:%s\n@w`FbNT:%s\n@Zo`FbNT:%02X", adr, data[iNum-1], iSum);
						MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
						return;
					}
				}
				if (lsAdr > lStartAddr) lsAdr = lStartAddr;
				if (leAdr < (lStartAddr+iNum-1)) leAdr = (lStartAddr+iNum-1);
				lStartAddr += 4096; /* Xe[gZ[uf[^̃C[WAhX܂ŃXLbv */
				memcpy((cpStateBuffer+lStartAddr), wbuf, iNum-1);
			}
		}
		iSum = 0;
		memset(rbuf, 0x00, sizeof(rbuf));
		memset(cbuf, 0x00, sizeof(cbuf));
	}
	fclose(fp);
	memset(buf, 0x00, sizeof(buf));
	snprintf(buf, sizeof(buf), "܂\nAhX:$%04X - $%04X", lsAdr, leAdr);
	MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONINFORMATION);
}

static void RewriteStateFile(const char *FileName)
{
HANDLE hFile;
DWORD dwWriteBytes;
char szNewFile[MAX_PATH];

	strncpy(szNewFile, FileName, MAX_PATH);
	strcat(szNewFile, ".old");
	MoveFile(FileName, szNewFile);
	if ((hFile = CreateFile(FileName, GENERIC_WRITE, 0, NULL,
		OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL)) == INVALID_HANDLE_VALUE) {
		MessageBox( NULL, "Xe[gZ[uf[^I[vł܂BgpAANZXȂǂ̊mFĂB",
			TITLE_LINE, MB_OK | MB_ICONSTOP);
		return;
	}
	WriteFile(hFile, cpStateBuffer, lStateSize, &dwWriteBytes, NULL);
	if ((long)dwWriteBytes != lStateSize) {
		MessageBox(NULL, "Xe[gZ[ue𐳏ɏ߂܂łB", TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return;
	}
	CloseHandle(hFile);
}

/** CCallback֐ **/
#pragma warn -par
DWORD FAR PASCAL MainProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
static char szSaveFileName[MAX_PATH];
static char szDumpFileName[MAX_PATH];
static char szDropFileName[MAX_PATH];
static int	bType = 0;
static int	bSum = 1;
static int	bAddSum = 0;
static char szStartAddr[5];
OPENFILENAME	OFN;
char	Filter[256], szCurDir[MAX_PATH], buf[512];
int	sPos, tmp;
POINT ptDrop;
DWORD err;

	switch (message) {
/** _CAȌ **/
		case WM_INITDIALOG:
			GetWindowRect(GetDlgItem(hWnd, IDC_EDIT1), &rctEdit1);
			GetWindowRect(GetDlgItem(hWnd, IDC_EDIT2), &rctEdit2);
			DragAcceptFiles(hWnd, TRUE);
			memset(szSaveFileName, 0x00, sizeof(szSaveFileName));
			memset(szDumpFileName, 0x00, sizeof(szDumpFileName));
			if (bType == 0)
				CheckRadioButton(hWnd, IDC_RADIOBUTTON1, IDC_RADIOBUTTON2,
					IDC_RADIOBUTTON1);
			else
				CheckRadioButton(hWnd, IDC_RADIOBUTTON1, IDC_RADIOBUTTON2,
					IDC_RADIOBUTTON2);
			if (bSum == 0)
				CheckDlgButton(hWnd, IDC_CHECKBOX1, FALSE);
			else
				CheckDlgButton(hWnd, IDC_CHECKBOX1, TRUE);
			if (bAddSum == 0)
				CheckDlgButton(hWnd, IDC_CHECKBOX2, FALSE);
			else
				CheckDlgButton(hWnd, IDC_CHECKBOX2, TRUE);
			EnableWindow(GetDlgItem(hWnd, IDC_BUTTON4), FALSE);
			break;

/** t@C̃hbv **/
		case WM_DROPFILES:
			/* hbvꂽt@C1ڂ̗pă_CAO֏o */
			DragQueryPoint((HDROP)wParam, &ptDrop);
			DragQueryFile((HDROP)wParam, 0, szDropFileName, MAX_PATH);
			DragFinish((HDROP)wParam);
			ptDrop.y += GetSystemMetrics(SM_CYCAPTION);
			/* Xe[gZ[uf[^̃hbv͈̓`FbNBQƃ{^̈ʒuGfBbg{bNX܂ */
			if ((ptDrop.x >= rctEdit1.left && ptDrop.x <= rctEdit1.right) &&
				(ptDrop.y >= rctEdit1.top && ptDrop.y <= rctEdit1.bottom)) {
				if (strlen(szSaveFileName) != 0 && strcmp(szSaveFileName, szDropFileName) != 0) {
					if (MessageBox(NULL, "Xe[gZ[uf[^u܂H", TITLE_LINE, MB_YESNO | MB_ICONQUESTION) == IDCANCEL)
						break;
				}
				SetDlgItemText(hWnd, IDC_EDIT1, szDropFileName);
				strcpy(szSaveFileName, szDropFileName);
				ReadSateFile(szSaveFileName);
				if (CheckEmz(cpStateBuffer))
					MessageBox(NULL, "Xe[gZ[uf[^s̉\܂B\nɏȂ\܂B", TITLE_LINE, MB_OK | MB_ICONEXCLAMATION);
				InvalidateRect(hWnd, NULL, TRUE);
			}
			/* _vt@C̃hbv͈̓`FbNBQƃ{^̈ʒuGfBbg{bNX܂ */
			if ((ptDrop.x >= rctEdit2.left && ptDrop.x <= rctEdit2.right) &&
				(ptDrop.y >= rctEdit2.top && ptDrop.y <= rctEdit2.bottom)) {
				SetDlgItemText(hWnd, IDC_EDIT2, szDropFileName);
				strcpy(szDumpFileName, szDropFileName);
				InvalidateRect(hWnd, NULL, TRUE);
			}
			break;

		// {^ñR}h
		case WM_COMMAND:
			switch(wParam) {
				case IDC_BUTTON1:	// Xe[gZ[uQ
					/* J_CAOoăt@CIĂ炤 */
					memset(szCurDir, 0x00, sizeof(szCurDir));
					memset(&OFN, 0x00, sizeof(OFN));
					memset(Filter, 0x00, sizeof(Filter));
					strcpy(Filter, "Xe[gZ[uf[^ (*.mze)");
					sPos = strlen(Filter);
					strcpy(&Filter[sPos+1], "*.mze");
					OFN.lStructSize = sizeof(OPENFILENAME);
					OFN.hwndOwner = hWnd;
					OFN.hInstance = hInst;
					OFN.lpstrFilter = Filter;
					OFN.lpstrCustomFilter = NULL;
					OFN.nMaxCustFilter = 0;
					OFN.nFilterIndex = 0;
					OFN.lpstrFile = szCurDir;
					OFN.nMaxFile = sizeof(szCurDir);
					OFN.lpstrInitialDir = NULL;
					OFN.lpstrFileTitle = NULL;
					OFN.nMaxFileTitle = 0;
					OFN.lpstrTitle = "Xe[gZ[uf[^t@C̑I";
					OFN.nFileOffset = 0;
					OFN.nFileExtension = 0;
					OFN.lpstrDefExt = NULL;
					OFN.lCustData = NULL;
					OFN.lpfnHook = NULL;
					OFN.lpTemplateName = NULL;
					OFN.Flags = OFN_EXPLORER | OFN_HIDEREADONLY | OFN_FILEMUSTEXIST;
					if (GetOpenFileName(&OFN)) {
						SetDlgItemText(hWnd, IDC_EDIT1, OFN.lpstrFile);
						strcpy(szSaveFileName, OFN.lpstrFile);
						ReadSateFile(szSaveFileName);
						if (CheckEmz(cpStateBuffer))
							MessageBox(NULL, "Xe[gZ[uf[^s̉\܂B\nɏȂ\܂B", TITLE_LINE, MB_OK | MB_ICONEXCLAMATION);
						InvalidateRect(hWnd, NULL, TRUE);
//					} else {
//						err = CommDlgExtendedError();
//						memset(buf, 0x00, sizeof(buf));
//						snprintf(buf, sizeof(buf), "result: %04x", err);
//						MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
					}
					/* _CAOLZꂽ牽Ȃ */
					break;

				case IDC_BUTTON2:	// _vt@CQ
					/* J_CAOoăt@CIĂ炤 */
					memset(szCurDir, 0x00, sizeof(szCurDir));
					memset(&OFN, 0x00, sizeof(OFN));
					memset(Filter, 0x00, sizeof(Filter));
					strcpy(Filter, "_vt@C (*.*)");
					sPos = strlen(Filter);
					strcpy(&Filter[sPos+1], "*.*");
					OFN.lStructSize = sizeof(OPENFILENAME);
					OFN.hwndOwner = hWnd;
					OFN.hInstance = hInst;
					OFN.lpstrFilter = Filter;
					OFN.lpstrCustomFilter = NULL;
					OFN.nMaxCustFilter = 0;
					OFN.nFilterIndex = 0;
					OFN.lpstrFile = szCurDir;
					OFN.lpstrInitialDir = NULL;
					OFN.nMaxFile = sizeof(szCurDir);
					OFN.lpstrFileTitle = NULL;
					OFN.nMaxFileTitle = 0;
					OFN.lpstrTitle = "_vt@C̑I";
					OFN.nFileOffset = 0;
					OFN.nFileExtension = 0;
					OFN.lpstrDefExt = NULL;
					OFN.lCustData = NULL;
					OFN.lpfnHook = NULL;
					OFN.lpTemplateName = NULL;
					OFN.Flags = OFN_EXPLORER | OFN_HIDEREADONLY | OFN_FILEMUSTEXIST;
					if (GetOpenFileName(&OFN)) {
						SetDlgItemText(hWnd, IDC_EDIT2, OFN.lpstrFile);
						strcpy(szDumpFileName, OFN.lpstrFile);
						InvalidateRect(hWnd, NULL, TRUE);
//					} else {
//						err = CommDlgExtendedError();
//						memset(buf, 0x00, sizeof(buf));
//						snprintf(buf, sizeof(buf), "result: %04x", err);
//						MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
					}
					/* _CAOLZꂽ牽Ȃ */
					break;

				case IDC_BUTTON3:	// _vf
//					memset(szSaveFileName, 0x00, sizeof(szSaveFileName));
//					GetDlgItemText(hWnd, IDC_EDIT1, szSaveFileName, sizeof(szSaveFileName));
//					memset(szDumpFileName, 0x00, sizeof(szDumpFileName));
//					GetDlgItemText(hWnd, IDC_EDIT2, szDumpFileName, sizeof(szDumpFileName));
					if (cpStateBuffer == NULL) {
						ReadSateFile(szSaveFileName);
						if (CheckEmz(cpStateBuffer))
							MessageBox(NULL, "Xe[gZ[uf[^s̉\܂B\nɏȂ\܂B", TITLE_LINE, MB_OK | MB_ICONEXCLAMATION);
					}
					if (strlen(szSaveFileName) == 0) {
						MessageBox(NULL, "Xe[gZ[uf[^w肵ĂB", TITLE_LINE, MB_OK | MB_ICONSTOP);
						break;
					}
					if (strlen(szDumpFileName) == 0) {
						MessageBox(NULL, "_vt@Cw肵ĂB", TITLE_LINE, MB_OK | MB_ICONSTOP);
						break;
					}
					if (IsDlgButtonChecked(hWnd, IDC_RADIOBUTTON1))
						bType = 0;
					else
						bType = 1;
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX1))
						bSum = 1;
					else
						bSum = 0;
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX2))
						bAddSum = 1;
					else
						bAddSum = 0;
					memset(szStartAddr, 0x00, sizeof(szStartAddr));
					GetDlgItemText(hWnd, IDC_EDIT3, szStartAddr, 5);
					if (bType == 1) {
						BinaryProc(szDumpFileName, szStartAddr);
					} else {
						TextProc(szDumpFileName, bSum, bAddSum);
					}
					EnableWindow(GetDlgItem(hWnd, IDC_BUTTON4), TRUE);
					break;

				case IDC_BUTTON4:
					RewriteStateFile(szSaveFileName);
					MessageBox(NULL, "݊", TITLE_LINE, MB_OK);
					break;

				case IDC_BUTTON5:		// About...{^
					/* About̃_CAOo */
					DialogBox(hInst, "AboutBox", hWnd, (DLGPROC)About);
					break;

				case IDCANCEL:	// I{^
					DestroyWindow(hWnd);
					PostQuitMessage(0);
					break;

			}
			break;
	}
	return (FALSE);
}
#pragma warn .par

#pragma warn -par
/** AboutBox_CAO{ OK{^ꂽIBȊO͉Ȃ **/
BOOL CALLBACK _export About(HWND hDlg, unsigned message, WORD wParam,
		LONG lParam)
{

	switch (message) {

		/** ڑĨbZ[W **/
		case WM_COMMAND:
			if (wParam == IDOK) {
				EndDialog(hDlg, TRUE);
				return (FALSE);
			}
			break;

		default:
			return(FALSE);
    }
	return (TRUE);
}
#pragma warn .par

/**  WindowsCGg...NƂsB C_CAOoďIB**/
#pragma warn -par
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
	LPSTR lpCmdLine, int nCmdShow)
{
	hInst = hInstance;
	return (DialogBox(hInst, "MainDialog", NULL, (DLGPROC)MainProc));
}
#pragma warn .par
/** ========================= End of Source ============================== **/
